HDU 4405 Aeroplane chess(一维概率dp)

来源:互联网 发布:php高级工程师 编辑:程序博客网 时间:2024/06/06 02:29

大体题意:

一维的飞行棋,你从0点开始出发,到n点,你有一个骰子,如果点数是x的话,你能走到i + x的位置,其中i是你的当前位置,求掷骰子次数的最少期望值? 其中会在某一个点由飞行器,直接从x飞到y,是必须飞!!

思路:

很水的一个概率dp了,令dp[i]表示从i位置出发到n 的期望值!

显然dp[n] = 0;

倒着递推显然更好做,更容易理解一些!

在i 位置,如果有飞行器的话,直接令dp[i] = dp[g[i]]了,!

如果没有,就要考虑掷骰子,你掷一次的点数可能为1,2,3,4,5,6,那么期望就是dp[i+1]*1/6 + dp[i+2]*1/6....+dp[i+6]*1/6 + 1  。

dp[0]便是答案。

#include <cstdio>#include <iostream>#include <cstring>using namespace std;int n,m;double dp[100000+7];int g[100000+7];int main(){    while(~scanf("%d %d",&n, &m) && (n || m)){        memset(dp,0,sizeof dp);        memset(g,-1,sizeof g);        dp[n] = 0;        for (int i = 0; i < m; ++i){            int x,y;            scanf("%d %d",&x,&y);            g[x] = y;        }        for (int i = n-1; i >= 0; --i){            if (~g[i]){                dp[i] = dp[g[i]];                continue;// 有飞行器的话,必须飞。            }            double sum = 0;            for (int j = 1; j < 7; ++j) sum += dp[i+j];            sum = sum /6.0 + 1;            dp[i] = sum;        }        printf("%.4f\n",dp[0]);    }    return 0;}

Aeroplane chess

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3773    Accepted Submission(s): 2396


Problem Description
Hzz loves aeroplane chess very much. The chess map contains N+1 grids labeled from 0 to N. Hzz starts at grid 0. For each step he throws a dice(a dice have six faces with equal probability to face up and the numbers on the faces are 1,2,3,4,5,6). When Hzz is at grid i and the dice number is x, he will moves to grid i+x. Hzz finishes the game when i+x is equal to or greater than N.

There are also M flight lines on the chess map. The i-th flight line can help Hzz fly from grid Xi to Yi (0<Xi<Yi<=N) without throwing the dice. If there is another flight line from Yi, Hzz can take the flight line continuously. It is granted that there is no two or more flight lines start from the same grid.

Please help Hzz calculate the expected dice throwing times to finish the game.
 

Input
There are multiple test cases. 
Each test case contains several lines.
The first line contains two integers N(1≤N≤100000) and M(0≤M≤1000).
Then M lines follow, each line contains two integers Xi,Yi(1≤Xi<Yi≤N).  
The input end with N=0, M=0. 
 

Output
For each test case in the input, you should output a line indicating the expected dice throwing times. Output should be rounded to 4 digits after decimal point.
 

Sample Input
2 08 32 44 57 80 0
 

Sample Output
1.16672.3441
 

Source
2012 ACM/ICPC Asia Regional Jinhua Online
 

Recommend
zhoujiaqi2010   |   We have carefully selected several similar problems for you:  6010 6009 6008 6007 6006 
 


0 0
原创粉丝点击